unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, INIEnt, INISec, ExtCtrls, Buttons, INISaver, INISecEx, INIEntEx,INIFindS,
  INIEntDB, INIUtil;

type
  TFDemo = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    INIFormSaver: TINIFormSaver;
    INIDatabase: TINIDatabase;
    secDispMsgs: TINISection;
    secDispMsgsList: TINIEntrySubSection;
    secDispMsgList: TINIMultiSection;
    secDispMsgListScrolledMsg: TINIEntryString;
    secDispMsgListScrollSpeed: TINIEntryInteger;
    secDispMsgsINIEntrySubSection1: TINIEntrySubSection;
    secDisplay: TINIMultiSection;
    secDisplayDispCOM: TINIEntryOneOfStrings;
    secDisplayDispRows: TINIEntryInteger;
    secDisplayDispCols: TINIEntryInteger;
    secDisplayInitDisplay: TINIEntryString;
    secDisplayClearDisp: TINIEntryString;
    secDisplayLocateDisp1: TINIEntryString;
    secDisplayLocateDisp2: TINIEntryString;
    secDefinitions: TINISection;
    secDefinitionsPorts: TINIEntrySubSection;
    secPorts: TINIMultiSection;
    secPortsBaudRate: TINIEntryOneOfStrings;
    secPortsParity: TINIEntryOneOfStrings;
    secPortsDataBits: TINIEntryInteger;
    secPortsStopBits: TINIEntryOneOfStrings;
    secPortsInBuffer: TINIEntryInteger;
    secPortsOutBuffer: TINIEntryInteger;
    secAppOthersPapers: TINIEntrySubSection;
    secPapers: TINIMultiSection;
    secPapersW: TINIEntryInteger;
    secPapersH: TINIEntryInteger;
    secModem: TINISection;
    secModemExitMode: TINIEntryOneOfStrings;
    secModemOnError: TINIEntryOneOfStrings;
    secModemOverwrites: TINIEntryOneOfStrings;
    secModemTimeOut: TINIEntryInteger;
    secModemRetry: TINIEntryInteger;
    secModemDelay: TINIEntryInteger;
    secModemConfig: TINIEntryString;
    secModemPCAPath: TINIEntryString;
    secModemPort: TINIEntryOneOfStrings;
    secApp: TINISection;
    secControlsXOffset: TINIEntryInteger;
    secControlsYOffset: TINIEntryInteger;
    secMainss2: TINIEntrySubSection;
    secPrinter: TINIMultiSection;
    secPrinterConnect: TINIEntryOneOfStrings;
    secPrinterZnakova: TINIEntryInteger;
    secPrinterLinija: TINIEntryInteger;
    secPrinterkomandeBase: TINIEntryOneOfStrings;
    secPrinterFile: TINIEntryString;
    secPrinteralwNew: TINIEntryBoolean;
    secPrinterkomInit: TINIEntryString;
    secPrinterkomDoubleW: TINIEntryString;
    secPrinterkomDoubleH: TINIEntryString;
    secPrinterkomNormal: TINIEntryString;
    secPrinterkomBold: TINIEntryString;
    secPrinterkomItalic: TINIEntryString;
    secPrinterkomUnderLine: TINIEntryString;
    secPrinterkomDoubleStrike: TINIEntryString;
    secPrinterkomCondensed: TINIEntryString;
    secPrinterkomFont1: TINIEntryString;
    secPrinterkomFont2: TINIEntryString;
    secPrinterkomFont3: TINIEntryString;
    secPrinterkomFont4: TINIEntryString;
    secPrinterkomSize1: TINIEntryString;
    secPrinterkomSize2: TINIEntryString;
    secPrinterkomSize3: TINIEntryString;
    secPrinterkomSize4: TINIEntryString;
    secPrinterkom144inch: TINIEntryString;
    secPrinterkomCP1: TINIEntryString;
    secPrinterkomCP2: TINIEntryString;
    secPrinterkomSelectBlack: TINIEntryString;
    secPrinterkomSelectRed: TINIEntryString;
    secPrinterkomPartialCut: TINIEntryString;
    secPrinterkomFullCut: TINIEntryString;
    secPrinterkomNewLine: TINIEntryString;
    secPrinterconvOn: TINIEntryBoolean;
    secPrinterOldZnak: TINIEntryString;
    secPrinternewZnak: TINIEntryString;
    secPrintercharHorLine: TINIEntryString;
    secPrintercharVertLine: TINIEntryString;
    secMainss3: TINIEntrySubSection;
    secControls: TINIMultiSection;
    secControlsStil: TINIEntryOneOfStrings;
    secControlsIspisi: TINIEntryBoolean;
    secControlsEnabled: TINIEntryBoolean;
    secControlsDefault: TINIEntryString;
    secControlsFormat: TINIEntryString;
    secControlsX: TINIEntryInteger;
    secControlsY: TINIEntryInteger;
    secControlsIndeks: TINIEntryInteger;
    secMainss4: TINIEntrySubSection;
    secPrinterStyles: TINISection;
    secIspisistil: TINIEntrySubSection;
    secStyles: TINIMultiSection;
    secStylesnormal: TINIEntryBoolean;
    secStylesdoubleW: TINIEntryBoolean;
    secStylesdoubleH: TINIEntryBoolean;
    secStylesbold: TINIEntryBoolean;
    secStylesitalic: TINIEntryBoolean;
    secStylesunderline: TINIEntryBoolean;
    secStylesdoublestrike: TINIEntryBoolean;
    secStylescondensed: TINIEntryBoolean;
    secStylesnextC: TINIEntryNextColumn;
    secStylesSize: TINIEntryInteger;
    secStylesFW: TINIEntryFloat;
    secStylesFH: TINIEntryFloat;
    secStylesBoja: TINIEntryColor;
    secStylesCodePage: TINIEntryOneOfStrings;
    secStylesposebComm: TINIEntrySubSection;
    secSpecStil: TINIMultiSection;
    secSpecStilspecCommand: TINIEntryString;
    secPrinterStylesFontReplace: TINIEntrySubSection;
    secFonts: TINIMultiSection;
    secMainss5: TINIEntrySubSection;
    secDatabase: TINISection;
    secDatabaseToday: TINIEntryBoolean;
    secDatabasess2: TINIEntrySubSection;
    secPartners: TINIMultiSection;
    secPartnersName: TINIEntryString;
    secPartnersAddress: TINIEntryString;
    secPartnersCity: TINIEntryString;
    secPartnersBank: TINIEntryString;
    secDatabaseTomorrow: TINIEntryBoolean;
    secPrinterWinName: TINIEntryPrinterName;
    secStylesFont: TINIEntryFontName;
    secFontsFont: TINIEntryFontName;
    secForms: TINIMultiSectionFormSaver;
    secFormFont: TINISectionFont;
    sec30: TINISection;
    sec30Default: TINIEntryString;
    secLibrary: TINISection;
    secLibraryDefault: TINIEntryString;
    secLibrarySearchPath: TINIEntryString;
    secLibrarySaveLibrarySource: TINIEntryInteger;
    secLibraryMapFile: TINIEntryInteger;
    secLibraryDebugInfo: TINIEntryInteger;
    secLibraryShowHints: TINIEntryInteger;
    secLibraryShowWarnings: TINIEntryInteger;
    secLibraryUnitAliases: TINIEntryString;
    secLibraryPackageDCPOutputDir: TINIEntryString;
    secLibraryPackageDLLOutputDir: TINIEntryString;
    secActiveXControls: TINISection;
    secActiveXControlsDefault: TINIEntryString;
    secActiveXControlsUnitDirName: TINIEntryString;
    secPaletteDefaults: TINISection;
    secPaletteDefaultsDefault: TINIEntryString;
    secPaletteDefaultsStandard: TINIEntryString;
    secPaletteDefaultsAdditional: TINIEntryString;
    secPaletteDefaultsWin32: TINIEntryString;
    secPaletteDefaultsSystem: TINIEntryString;
    secPaletteDefaultsInternet: TINIEntryString;
    secPaletteDefaultsDataAccess: TINIEntryString;
    secPaletteDefaultsDataAccessHidden: TINIEntryString;
    secPaletteDefaultsDataControls: TINIEntryString;
    secPaletteDefaultsDecisionCube: TINIEntryString;
    secPaletteDefaultsQReport: TINIEntryString;
    secPaletteDefaultsDialogs: TINIEntryString;
    secPaletteDefaultsWin31: TINIEntryString;
    secPaletteDefaultsSamples: TINIEntryString;
    secPaletteDefaultsActiveX: TINIEntryString;
    secExperts: TINISection;
    secExpertsDefault: TINIEntryString;
    secExpertsExptDemo: TINIEntryString;
    secDesktop: TINISection;
    secDesktopDefault: TINIEntryString;
    secDesktopSaveSymbols: TINIEntryInteger;
    secAutoSave: TINISection;
    secAutoSaveDefault: TINIEntryString;
    secAutoSaveEditorFiles: TINIEntryInteger;
    secAutoSaveDesktopFile: TINIEntryInteger;
    secFormFontApply: TINIEntryButton;
    secThisDemo: TINISection;
    secThisDemoSelectedSection: TINIEntryInteger;
    CheckBox1: TCheckBox;
    secThisDemoHideEditPanel: TINIEntryBoolean;
    secAllEntries: TINISection;
    secAllEntriesString: TINIEntryString;
    secAllEntriesFloat: TINIEntryFloat;
    secAllEntriesInteger: TINIEntryInteger;
    secAllEntriesBoolean: TINIEntryBoolean;
    secAllEntriesOneOfStrings: TINIEntryOneOfStrings;
    secAllEntriesManyOfStrings: TINIEntryManyOfStrings;
    secAllEntriesShortcut: TINIEntryShortCut;
    secAllEntriesSeparator: TINIEntrySeparator;
    secAllEntriesNextColumn: TINIEntryNextColumn;
    secAllEntriesButton: TINIEntryButton;
    secAllEntriesDate: TINIEntryDate;
    secAllEntriesFontName: TINIEntryFontName;
    secAllEntriesPrinterName: TINIEntryPrinterName;
    secAllEntriesOneOfStrings1: TINIEntryOneOfStrings;
    secAllEntriesSaveList: TINIEntrySaveList;
    secAllEntriesPaintBox: TINIEntryPaintBox;
    ImageList: TImageList;
    sec30PB: TINIEntryPaintBox;
    secBitBtn3: TINISectionComponent;
    secBitBtn3Cancel: TINIEntryOneOfStrings;
    secBitBtn3Caption: TINIEntryString;
    secBitBtn3Cursor: TINIEntryInteger;
    secBitBtn3Default: TINIEntryOneOfStrings;
    secBitBtn3DragCursor: TINIEntryInteger;
    secBitBtn3DragMode: TINIEntryOneOfStrings;
    secBitBtn3Enabled: TINIEntryOneOfStrings;
    secFont: TINISectionComponent;
    secFontCharset: TINIEntryInteger;
    secFontColor: TINIEntryInteger;
    secFontHeight: TINIEntryInteger;
    secFontName: TINIEntryString;
    secFontPitch: TINIEntryOneOfStrings;
    secFontSize: TINIEntryInteger;
    secFontStyle: TINIEntryManyOfStrings;
    secBitBtn3Height: TINIEntryInteger;
    secBitBtn3HelpContext: TINIEntryInteger;
    secBitBtn3Hint: TINIEntryString;
    secBitBtn3Kind: TINIEntryOneOfStrings;
    secBitBtn3Layout: TINIEntryOneOfStrings;
    secBitBtn3Left: TINIEntryInteger;
    secBitBtn3Margin: TINIEntryInteger;
    secBitBtn3ModalResult: TINIEntryInteger;
    secBitBtn3Name: TINIEntryString;
    secBitBtn3NumGlyphs: TINIEntryInteger;
    secBitBtn3ParentFont: TINIEntryOneOfStrings;
    secBitBtn3ParentShowHint: TINIEntryOneOfStrings;
    secBitBtn3ShowHint: TINIEntryOneOfStrings;
    secBitBtn3Spacing: TINIEntryInteger;
    secBitBtn3Style: TINIEntryOneOfStrings;
    secBitBtn3TabOrder: TINIEntryInteger;
    secBitBtn3TabStop: TINIEntryOneOfStrings;
    secBitBtn3Tag: TINIEntryInteger;
    secBitBtn3Top: TINIEntryInteger;
    secBitBtn3Visible: TINIEntryOneOfStrings;
    secBitBtn3Width: TINIEntryInteger;
    sec30PB1: TINIEntryPaintBox;
    secBitBtn3Apply: TINIEntryButton;
    secDisplayMessage: TINIEntryOneOfStrings;
    secAllEntriesBinaryValue: TINIEntryBinary;
    pnlEdit: TPanel;
    secAppearance: TINISection;
    secAppearanceDefault: TINIEntryString;
    secAppearanceCustomColors: TINIEntryBinary;
    secAppearanceCurrent: TINIEntryString;
    secSchemes: TINISection;
    secSchemesDefault: TINIEntryString;
    secSchemesBrick: TINIEntryBinary;
    secSchemesMaple: TINIEntryBinary;
    secSchemesSpruce: TINIEntryBinary;
    secSchemesTealVGA: TINIEntryBinary;
    secSchemesRedWhiteAndBlueVGA: TINIEntryBinary;
    secSchemesWheat: TINIEntryBinary;
    secSchemesPumpkinLarge: TINIEntryBinary;
    secSchemesEggplant: TINIEntryBinary;
    secSchemesRainyDay: TINIEntryBinary;
    secSchemesDesert: TINIEntryBinary;
    secSchemesMarineHighColor: TINIEntryBinary;
    secSchemesWindowsStandardExtraLarge: TINIEntryBinary;
    secSchemesStormVGA: TINIEntryBinary;
    secSchemesWindowsStandard: TINIEntryBinary;
    secSchemesWindowsStandardLarge: TINIEntryBinary;
    secSchemesRose: TINIEntryBinary;
    secSchemesHighContrastBlackLarge: TINIEntryBinary;
    secSchemesHighContrastBlackExtraLarge: TINIEntryBinary;
    secSchemesHighContrastWhiteLarge: TINIEntryBinary;
    secSchemesHighContrastWhiteExtraLarge: TINIEntryBinary;
    secSchemesRoseLarge: TINIEntryBinary;
    secSchemesLilac: TINIEntryBinary;
    secSchemesLilacLarge: TINIEntryBinary;
    secSchemesSlate: TINIEntryBinary;
    secSchemesPlumHighColor: TINIEntryBinary;
    secSchemesHighContrastBlack: TINIEntryBinary;
    secSchemesHighContrastWhite: TINIEntryBinary;
    secSchemesStandard: TINIEntryBinary;
    AutoAlignPanel1: TAutoAlignPanel;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    ComboBox1: TComboBox;
    BitBtn1: TBitBtn;
    BitBtn4: TBitBtn;
    sec30PB2: TINIEntryPaintBox;
    secPersons: TINIMultiSection;
    secPersonsPhone: TINIEntryString;
    secPartnersComment: TINIEntrySaveList;
    secPersonsName: TINIEntryString;
    secPartnersShowPartners: TINIEntryButton;
    secDispMsgListColor: TINIEntryColor;
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure secFormFontApplyClick(Sender: TObject);
    procedure INIDatabaseBeforeWrite(Sender: TObject);
    procedure secThisDemoHideEditPanelChange(Sender: TINIField);
    procedure secThisDemoSelectedSectionChange(Sender: TINIField);
    procedure secAllEntriesPaintBoxPaint(Sender: TObject);
    procedure sec30PBPaint(Sender: TObject);
    procedure sec30PB1Paint(Sender: TObject);
    procedure secBitBtn3ApplyClick(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure secPartnersShowPartnersClick(Sender: TObject);
  public
		function GetPartners:string;

		constructor Create(AOwner:TComponent); override;
  end;

var
  FDemo: TFDemo;

implementation

{$R *.DFM}

constructor TFDemo.Create(AOwner:TComponent);
var i:Integer;
begin
	inherited Create(AOwner);
  // read all

	INIDatabase.Read;

  // init entries that depends on other entries
	INIDatabase.Init;

  for i:=0 to ComponentCount-1 do begin
  	if Components[i] is TINICustomSection then ComboBox1.Items.AddObject(Components[i].Name,Components[i]);
  end;

  CheckBox1.Checked:=secThisDemoHideEditPanel.AsBoolean;
	ComboBox1.ItemIndex:=secThisDemoSelectedSection.AsInteger;

  // secFormFont is TINISectionFont
  // TINISectionFont is used to store information about font (name,size,style,color)

  secFormFont.SetFont(Font);
end;



procedure TFDemo.BitBtn2Click(Sender: TObject);
begin
	// hide parent panel
	pnlEdit.Visible:=not CheckBox1.Checked;

  try
  	// destroy all controls that it owns
    while pnlEdit.ControlCount>0 do pnlEdit.Controls[0].Free;

    // create all sections
    INIDatabase.CreatePages;

    finally
    	pnlEdit.Visible:=True;
  end;
end;

procedure TFDemo.BitBtn1Click(Sender: TObject);
begin
	// write all sections
	INIDatabase.Write;
end;

procedure TFDemo.BitBtn3Click(Sender: TObject);
begin
	pnlEdit.Visible:=not CheckBox1.Checked;

  try
		while pnlEdit.ControlCount>0 do pnlEdit.Controls[0].Free;

    // create only selected section
		INIDatabase.CreatePage(Self,ComboBox1.Items.Objects[ComboBox1.ItemIndex] as TINICustomSection,pnlEdit);

    finally
    	pnlEdit.Visible:=True;
  end;
end;


procedure TFDemo.secFormFontApplyClick(Sender: TObject);
begin
  secFormFont.SetFont(Font);
end;

procedure TFDemo.INIDatabaseBeforeWrite(Sender: TObject);
begin
	secThisDemoSelectedSection.AsInteger:=ComboBox1.ItemIndex;
  secThisDemoHideEditPanel.AsBoolean:=CheckBox1.Checked;
end;

procedure TFDemo.secThisDemoHideEditPanelChange(Sender: TINIField);
begin
  CheckBox1.Checked:=secThisDemoHideEditPanel.AsBoolean;
end;

procedure TFDemo.secThisDemoSelectedSectionChange(Sender: TINIField);
begin
	ComboBox1.ItemIndex:=secThisDemoSelectedSection.AsInteger;
end;

procedure TFDemo.secAllEntriesPaintBoxPaint(Sender: TObject);
var pb:TPaintBox;
begin
	pb:=secAllEntriesPaintBox.PaintBox;

  pb.Canvas.Brush.Color:=clWhite;

  pb.Canvas.FillRect(Rect(0,0,pb.Width,pb.Height));

  pb.Canvas.TextOut(2,2,'This is TINIEntryPaintBox');
  pb.Canvas.Draw(pb.Width div 2,pb.Height div 2,(secAllEntriesButton.Control as TBitBtn).Glyph);
end;

procedure TFDemo.sec30PBPaint(Sender: TObject);
begin
	(Sender as TPaintBox).Canvas.Font.Color:=clRed;
	(Sender as TPaintBox).Canvas.TextOut(2,2,'Structure of this page is read from registry !!');
end;

procedure TFDemo.sec30PB1Paint(Sender: TObject);
begin
	(Sender as TPaintBox).Canvas.Font.Color:=clGreen;
	(Sender as TPaintBox).Canvas.TextOut(2,2,'Structure of this page is read from control BitBtn3 !!');
end;

procedure TFDemo.secBitBtn3ApplyClick(Sender: TObject);
begin
	secBitBtn3.SetObjectProperties(BitBtn3);
end;

procedure TFDemo.BitBtn4Click(Sender: TObject);
begin
	INIDatabase.Write;

	Close;
end;

function TFDemo.GetPartners:string;

	function CheckEmpty(const Field:string):string;
  begin
  	if Field<>'' then
    	Result:=Field
    else
    	Result:='<empty>';
  end;

begin
	secPartners.BeginWalk;
	secPersons.BeginWalk;

  try
    Result:='';

    secPartners.First;   // first item

    while not secPartners.EOL do begin  // while not end of list
      Result:=Result+secPartners.Key+',';
      Result:=Result+CheckEmpty(secPartners.FieldByName('Name').AsString)+',';						// access field by name
      Result:=Result+CheckEmpty(secPartnersAddress.AsString)+#32;													// access field directly

      secPersons.First;			// secPersons is sub-section of secPartners

      Result:=Result+'( ';

      while not secPersons.EOL do begin
        Result:=Result+secPersons.Key+#32+CheckEmpty(secPersons.FieldByName('Name').AsString)+'=';
        Result:=Result+CheckEmpty(secPersons.FieldByName('Phone').AsString)+'; ';

        secPersons.Next;
      end;

      Result:=Result+')'+#13+#13;

      secPartners.Next;		// next item
    end;

  finally
		secPersons.EndWalk;
  	secPartners.EndWalk;
  end;
end;

procedure TFDemo.secPartnersShowPartnersClick(Sender: TObject);
begin
	MessageDlg(GetPartners,mtInformation,[mbOK],0);
end;

end.


