{$O+A+W-U-I+B-X+T-P+H+J+R-Q-D-L-}

//******************************************************
//******************************************************
// Project: Delphi Initialization Database
// Author: JBD
// E-mail: binel@alf.tel.hr
// Comment: About dialog
//******************************************************
//******************************************************

unit INIAbout;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Buttons, FSaver,ShellApi, INISec, INIEnt;

type
  TfrmAbout = class(TForm)
    BBOK: TBitBtn;
    Label1: TEdit;
    Label7: TEdit;
    FormSaver: TFormSaver;
    Panel1: TPanel;
    Label2: TLabel;
    Image1: TImage;
    Panel2: TPanel;
    Panel3: TPanel;
    Image2: TImage;
    Label3: TEdit;
    Label4: TEdit;
    Label5: TLabel;
    Label6: TEdit;
    Label8: TEdit;
    Label9: TLabel;
    EWWW: TLabel;
    lblMFC: TEdit;
    EEMail: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure EWWWClick(Sender: TObject);
    procedure EEMailClick(Sender: TObject);
  end;

var
  frmAbout: TfrmAbout;

implementation

uses INIUtil;

{$R *.DFM}

procedure TfrmAbout.FormCreate(Sender: TObject);
begin
	Screen.Cursors[101]:=LoadCursor(HInstance,MAKEINTRESOURCE(10101));

  EWWW.Cursor:=101;
  EEMail.Cursor:=101;
end;

procedure TfrmAbout.EWWWClick(Sender: TObject);
var lGotoWeb:TGotoWeb;
begin
  lGotoWeb:=TGotoWeb.Create(Self);

  try
  	lGotoWeb.URL:='http://'+EWWW.Caption;
  	lGotoWeb.Execute;

  	finally
    	lGotoWeb.Free;
  end;
end;

procedure TfrmAbout.EEMailClick(Sender: TObject);
var sEMail:string;
    SEI:TShellExecuteInfo;
begin
	sEMail:='"'+EEMail.Caption+'"'+#0;

  SEI.cbSize:=SizeOf(TShellExecuteInfo);
  SEI.fMask:=SEE_MASK_CLASSNAME;
  SEI.lpParameters:=nil;
  SEI.lpFile:=@(sEMail[1]);
  SEI.lpVerb:=nil;
  SEI.lpDirectory:=nil;
  SEI.lpClass:='MailTo';
  SEI.nShow:=SW_RESTORE;
  SEI.hInstApp:=Application.Handle;

  ShellExecuteEx(@SEI);
end;

end.
